#ifndef NB_GHOST_LAYERS_TESTER_HPP
#define NB_GHOST_LAYERS_TESTER_HPP

#include <cstddef>
#include <utils/GlobalVariableManager.hpp>

class NbGhostLayersTester
{
 private:
  const size_t m_original_number_of_ghost_layers;

 public:
  PUGS_INLINE
  NbGhostLayersTester(const size_t number_of_ghost_layers)
    : m_original_number_of_ghost_layers{GlobalVariableManager::instance().getNumberOfGhostLayers()}
  {
    GlobalVariableManager::instance().m_number_of_ghost_layers = number_of_ghost_layers;
  }

  PUGS_INLINE
  ~NbGhostLayersTester()
  {
    GlobalVariableManager::instance().m_number_of_ghost_layers = m_original_number_of_ghost_layers;
  }
};

#endif   // NB_GHOST_LAYERS_TESTER_HPP
